/* --------------------------------------------------------------------*/
/*  HELPFUNCTIONS.H       Teemu Kilpelinen 30.05.2001				   */
/*   												          	       */
/* --------------------------------------------------------------------*/

#ifndef HELPFUNCTIONS_H
#define HELPFUNCTIONS_H

#include <s2t_defs.h>

#ifdef __cplusplus
extern "C" {
#endif

int Int16ToFloat(INT16* integer_buffer, SND_BUFFER signal, 
	int count_of_samples);

int Ms2Samples(int ms, int sampling_rate);

int NearestPowerOfTwo(int frame_length, int round_downwards);

float ComplexAbs(float real_part, float im_part);

int Hz2Index(float frequency, int sampling_rate, int frame_length);

float Hz2Mel(float Hz_frequency);

void LifteringCoefficients(FLOAT_ARRAY lifter_function, int lifter_type, 
						   int lifter_length);

void CepstralLiftering(FEATURE_VECTOR vector, FLOAT_ARRAY lifter_function,
					   int lifter_length);

void WriteFeatureTableToFile(FEATURE_TABLE table, int count_of_vectors, 
	int begin_element, int end_element, char* filename);

#ifdef __cplusplus
}
#endif

#endif /* HELPFUNCTIONS.H */