/* --------------------------------------------------------------------*/
/*  MEL-FUNCTIONS.H     Teemu Kilpelinen 20.10.2000				   */
/*   												          	       */
/* --------------------------------------------------------------------*/


#ifndef MEL_FUNCTIONS_H
#define MEL_FUNCTIONS_H

#include "s2t_defs.h"

typedef struct{

	int filter_begin,
		
		filter_end;

	FLOAT_ARRAY coeffs;

}FILTER;

typedef struct{
	
	int num_mel_filters;
	
	FILTER* filters;

}FILTER_BANK;

FILTER_BANK* CreateFilterBank(int count_of_filters, int length, 
	int sampling_rate); 

FILTER* GetFilter(FILTER_BANK* filter_bank, int filter_index);  

float FilterOutput(FILTER* filter, FLOAT_ARRAY frame);

int NumberOfMelFilters(int sampling_rate);

void ComputeLogFilteredSpectrum(FRAME_ARRAY frame, 
	FLOAT_ARRAY log_filtered_spectrum, FILTER_BANK* filter_bank, 
	USER_PARAMETERS* user_params);

void DCT(FEATURE_TABLE cepstrum, FLOAT_ARRAY log_filtered_spectrum, 
		int MFCC_ord, int num_mel_filters, int row); 						

#endif /* MEL-FUNCTIONS.H */