
/*

  File name: pre_FFT.cpp
  Teemu Kilpelinen 27.6.2000

  Tss on toteutettuna ennen FFT:n suorittamista tarvittavat funktiot. 
  1. Signaalin arvojen muuttaminen INT16-muodosta double-muotoon
  2. DC-komponentin poisto signaalista. Tm siirt signaalin "nollan
  ymprille". 
  3. Ylipstsuodatin, joka poistaa signaalista matalimmat, tunnistuksessa
  turhat taajuudet.
  4. Frameihin jako, jossa jaetaan sampletaulukko sopivan mittaisiin frameihin. 
*/

#include <stdio.h>
#include "waveread.h"
#include <windows.h>
#include "MEMCTRL.H"
#include <math.h>
#include "riff.h"
#define a 0.95


//1. Nytearvojen muuttaminen double-muotoon (ja skaalaus vlille -0.5..0.5)

int int16_to_double(INT16* buffer1, double* buffer2, int sampleja_luettu)
{	
	INT32 i;
	INT16 b;
	double c;
	
	printf("Starting Pre-FFT...\n");
	printf("INT16-buffer to double-buffer...");
	for (i=0; i < sampleja_luettu; i++){
		b = buffer1[i];
        c = ((double) b /*/pow(2,16) */); 
		buffer2[i] = c;
		}
	printf("OK");
	printf("\n");
		
return 0;
}




/*2. DC-komponentin poisto signaalista. Tm siirt signaalin "nollan
ymprille". */
int DC_poisto(double* buffer, int sampleja_luettu)
{

	INT32 i;
	double summa = 0;
	double k_arvo,b,c;
    	
	//Lasketaan kaikkien samplejen arvojen summa
	

	for (i=0; i < sampleja_luettu; i++)	    
		summa += (buffer[i]/(double)(sampleja_luettu));
		
	//Lasketaan samplejen keskiarvo
    
	k_arvo = summa;
	printf("Average rate of signal: %f\n", k_arvo);
	
	//vhennetn jokaisesta samplesta keskiarvo
	printf("DC-deleting...");	
	for (i=0; i < sampleja_luettu; i++){
		b = buffer[i];
        c = b - k_arvo; 
		buffer[i] = c;
		//printf("%d\n", Buffer[i]);}
		}
	printf("OK");
	printf("\n");
	
	return 0;
}



/* 3. Ylipstsuodatin, joka poistaa signaalista matalimmat, tunnistuksessa
turhat taajuudet. */
int ylipaasto(double* bufferi_doub, double* bufferi_doub2,  int sampleja_luettu)
{
	double b,c;
	INT32 i;
	
	printf("Overfloat filtering...");

	for (i=0; i < sampleja_luettu; i++){
        b = bufferi_doub[i];
        bufferi_doub2[i] = b;
		}
	
	for (i = (sampleja_luettu-1); i >= 0; i--){
		if(i == 0){
			b = (a * bufferi_doub2[sampleja_luettu-1]);
			c = bufferi_doub2[i];
			bufferi_doub[i] =  c - b;
			
			}
		else{
			b = (a * bufferi_doub2[i-1]);
			c = bufferi_doub2[i];
			bufferi_doub[i] =  c - b;
			}
		
	}
		
	printf("OK");
	printf("\n");
	printf("\n");
	
    return 0;
}


