
#include "waveread.h"
#include <windows.h>

#if defined(min) && defined(max)
#undef min
#undef max
#endif

#include <stdio.h>
#include "riff.h"





int WaveReadTableSize(char* WaveFilename, int* BufferSize) {
	WaveFile Wave;
	DDCRET Value;
	printf("Reading size of the buffer we going to need...");
	
	if ((Value = Wave.OpenForRead(WaveFilename)) != DDC_SUCCESS) return Value;
	*BufferSize = Wave.NumChannels() * Wave.NumSamples(); 
	DDCRET Close();
	
	printf("OK");
	printf("\n");
	printf("\n");
	return DDC_SUCCESS;
}


int WaveReadContents(char* WaveFilename, INT16* Buffer, int BufferSize,
						 int* Channels, int* SamplingRate, int* BitsPerSample, long* SamplesRead){
	WaveFile Wave;
	DDCRET Value;
	if ((Value = Wave.OpenForRead(WaveFilename)) != DDC_SUCCESS) return Value;
	
	printf("\n");
	*Channels = Wave.NumChannels();
	printf("Number of channels: %d\n", *Channels);
	
	*SamplingRate = Wave.SamplingRate();
	printf("Sampling rate: %d\n", *SamplingRate);
	
	*BitsPerSample = Wave.BitsPerSample();
	printf("Bits per sample: %d\n", *BitsPerSample); 
	//toimii tnne asti...	
	
	
	printf("Reading .wav to buffer...");
    for (*SamplesRead = 0; *SamplesRead < ((BufferSize) < Wave.NumChannels() * Wave.NumSamples() ? 
        (BufferSize) : Wave.NumChannels() * Wave.NumSamples()); (*SamplesRead)++){
		Value = Wave.ReadSample(&(Buffer[(*SamplesRead) * *Channels]));
		//printf("%d\n", Buffer[(*SamplesRead) * *Channels]);
		//printf("%d\n", Value);
		//printf("%d\n", *SamplesRead);
	    if (Value != DDC_SUCCESS) return Value;
        }
	printf("OK");
	printf("\n");
	printf("\n");
	
	return DDC_SUCCESS;
}




int WaveWrite(char* WaveFilename, INT16* Buffer, int Samples,
		      int Channels, int SamplingRate, int BitsPerSample){
	
	WaveFile Wave;
	DDCRET Value = Wave.OpenForWrite(WaveFilename, SamplingRate,
		BitsPerSample, Channels);
	if (Value != DDC_SUCCESS) return Value;
	for (int k = 0; k < Samples; k++) {
		Value = Wave.WriteSample(&(Buffer[k * Channels]));
		if (Value != DDC_SUCCESS) return Value;
	}
	return DDC_SUCCESS;
}
